/*
 * This Kotlin source file was generated by the Gradle 'init' task.
 */
package advent_of_code.day_one

import java.io.File
import java.util.*

fun main(args: Array<String>) {
    val numbers = File(args[0])
        .readText()
        .split('\n')
        .filter { it.isNotBlank() }
        .map(Integer::parseInt)
    val total = Integer.parseInt(args[1])
    val duo = findDuo(numbers, total)
    val trio = findTrio(numbers, total)

    if (duo.isNotEmpty()) {
        println(
            "Duo:\n" +
            "${duo.first()} + ${duo.last()} = $total\n" +
                    "${duo.first()} * ${duo.last()} = ${duo.first() * duo.last()}"
        )
    } else {
        println("Didn't find a duo which can be summed to $total.")
    }

    if (trio.isNotEmpty()) {
        println(
            "Trio:\n" +
            "${trio.first()} + ${trio[1]} + ${trio.last()} = $total\n" +
                    "${trio.first()} * ${trio[1]} * ${trio.last()} = " +
                    "${trio.first() * trio[1] * trio.last()}"
        )
    } else {
        println("Didn't find a trio which can be summed to $total.")
    }


}


fun findDuo (list: List<Int>, total:Int) : List<Int> {
    if (list.isEmpty())
        return listOf()
    val combination = combine (list.first(), list.drop(1), total);
    if (combination.isPresent) {
        return listOf(list.first(), combination.asInt)
    }
    return findDuo(list.drop(1), total)
}

/**
 * Find 3 numbers in this `list` whose sum will be the value in `total`
 */
fun findTrio(list:List<Int>, total:Int) : List<Int> {
    if (list.isEmpty()) {
        return listOf()
    }

    // Pair of potential numbers which summed with the head of the list
    // gives the total.
    val duo = findDuo(list.drop(1), total - list.first())

    if (duo.isNotEmpty()) {
        return listOf(list.first()).plus(duo)
    }
    return findTrio(list.drop(1), total)
}


/**
 * Returns and `OptionalInt` which will contain a value if there's a value in
 * `list` that when summed to `num` equals `total`. The `OptionalInt` will be
 * empty otherwise.
 */
fun combine(num: Int, list: List<Int>, total: Int) : OptionalInt {
    for (value in list) {
        if (value + num == total) {
            return OptionalInt.of(value)
        }
    }
    return OptionalInt.empty();
}

